# Wasmer Documentation

Wasmer provides multiple documentations. Here are some pointers:

* [The Wasmer runtime
  `README.md`](https://github.com/wasmerio/wasmer/blob/master/README.md)
  is a good start for the first steps, like installations, first runs etc.,
* [The public documentation](https://docs.wasmer.io/) contains all the
  documentation you need to learn about Wasmer and WebAssembly,
* [The Rust crates documentations](https://wasmerio.github.io/wasmer/)
  contain all the documentations to use the `wasmer-*` Rust crates,
  with many examples,
* [The collection of
  examples](https://github.com/wasmerio/wasmer/blob/master/examples/README.md)
  illustrates how to use Wasmer and its numerous features through very
  commented examples,
* [Documentations for all embeddings/language
  integrations](https://github.com/wasmerio/wasmer/blob/master/README.md):
  the Wasmer runtime can be embedded in various languages or
  environments, each embedding provides its own documentation, book
  etc.,
* [OS distro packaging
  notes](https://github.com/wasmerio/wasmer/blob/master/PACKAGING.md)
  contains notes about how to package Wasmer for OS distributions.
